%define py_site_pkgs %(python -c "from distutils.sysconfig import get_python_lib as f;print f()")
%define __os_install_post %{nil}
%define _localdir %{_usr}/local
%define _sharedir %{_usr}/share
%define _jbossdir %{_sharedir}/jbossas
%define _jbossuser jboss
%define __getent /usr/bin/getent
%define __groupadd /usr/sbin/groupadd
%define __useradd /usr/sbin/useradd
%define __usermod /usr/sbin/usermod
%define _engineeardir %{_datadir}/%{upname}/engine.ear
%define mead_build 1
%define uversion %(echo 2.0.techpreview1 | sed s/_/-/)
%define upname ovirt-engine

Name: rhsc
Version: 2.0.techpreview1
Release: 5%{?dist}
%if %mead_build
Source0: org.ovirt.engine-root-%{uversion}-sources.zip
Source1: engine-server-ear-%{uversion}.ear
Source2: engine-tools-common-%{uversion}.jar
Source3: engine-config-%{uversion}.jar
Source4: engineencryptutils-%{uversion}.jar
Source5: common-%{uversion}.jar
Source6: engine-notifier-service-%{uversion}.jar
Source7: compat-%{uversion}.jar
%else
Source0: %{upname}-%{version}.tar.gz
%endif
License: ASL 2.0
Summary: Management server for Open Virtualization
Group: Virtualization/Management
URL: http://www.ovirt.org

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}
BuildArch: noarch
BuildRequires: unzip
BuildRequires: openssl-devel
BuildRequires: gcc-c++
BuildRequires: make
Requires: java-1.6.0-openjdk
Requires: policycoreutils-python
Requires: cracklib-python
Requires: ntp
Requires: bind-utils
Requires: postgresql-server >= 8.4.7
Requires: postgresql-contrib >= 8.4.7
Requires: postgresql-jdbc
Requires: httpd
Requires: mod_ssl
Requires: %{name}-setup
Requires: %{name}-jboss-deps
Requires: %{name}-backend
Requires: %{name}-restapi
Requires: %{name}-genericapi
Requires: %{name}-userportal
Requires: %{name}-config
Requires: %{name}-notification-service
Requires: %{name}-dbscripts
Requires: %{name}-webadmin-portal
Requires: vdsm-bootstrap
Requires: openssl
Requires: yum-plugin-versionlock
#Requires: %{name}-iso-uploader
#Requires: %{name}-image-uploader
Requires: %{name}-log-collector
#Requires: rhev-guest-tools-iso

%description
oVirt Engine is a feature-rich
server virtualization management system that provides advanced capabilities
for managing the Open virtualization infrastructure for Servers and Desktops.

%package jboss-deps
Summary: Jboss dependencies of oVirt Engine
Group: Virtualization/Management
Requires: jbossas-standalone >= 7.2.0
Requires: jbossas-bundles >= 7.2.0
Requires: jbossas-modules-eap >= 7.2.0
Requires: %{name} = %{version}-%{release}

%description jboss-deps
The JBOSS dependencies of oVirt Engine

%package backend
Summary: Engine core of oVirt Engine
Group: Virtualization/Management
Requires: %{name} = %{version}-%{release}

%description backend
The backend engine of oVirt Engine

%package restapi
Summary: RESTful API for oVirt Engine
Group: Virtualization/Management
Requires: %{name} = %{version}-%{release}

%description restapi
The RESTful API for oVirt Engine

%package genericapi
Summary: Generic API for oVirt Engine
Group: Virtualization/Management
Requires: %{name} = %{version}-%{release}

%description genericapi
The generic API for oVirt Engine

%package setup
Summary: Setup and upgrade scripts for oVirt Engine
Group: Virtualization/Management
Requires: %{name}
Requires: lsof
Requires: nfs-utils

%description setup
Setup and upgrade scripts for oVirt Engine

%package dbscripts
Summary: Database scripts for oVirt Engine
Group: Virtualization/Management
Requires: %{name}

%description dbscripts
Database scripts for oVirt Engine

%package userportal
Summary: User Portal of oVirt Engine
Group: Virtualization/Management
Requires: %{name} = %{version}-%{release}

%description userportal
The user portal interface to oVirt Engine

%package webadmin-portal
Summary: Web Admin Portal of oVirt Engine
Group: Virtualization/Management
Requires: %{name}

%description webadmin-portal
The web administration interface to oVirt Engine

%package tools-common
Summary: Common libraries for  oVirt Engine Tools
Group: Virtualization/Management
Requires: %{name} = %{version}-%{release}
Requires: jakarta-commons-collections
Requires: jakarta-commons-logging
Requires: jakarta-commons-lang
Requires: jakarta-commons-codec
Requires: log4j
Requires: jakarta-commons-configuration
Requires: jakarta-commons-jxpath

%description tools-common
The common libraries used by oVirt Engine Tools

%package notification-service
Summary: Notification service for oVirt Engine Tools
Group: Virtualization/Management
Requires: %{name} = %{version}-%{release}
Requires: %{name}-tools-common = %{version}-%{release}
Requires: classpathx-mail

%description notification-service
The notification service used by oVirt Engine

%package config
Summary: Configuration tool for oVirt Engine
Group: Virtualization/Management
Requires: %{name}-tools-common = %{version}-%{release}

%description config
The configuration tool for oVirt Engine

#%package setup-plugin-allinone
#Summary: All-in-one plugin for oVirt Engine's setup
#Group: Virtualization/Management
#Requires: %{name}-setup
#Requires: %{name}-sdk
#Requires: vdsm

#%description setup-plugin-allinone
#All-in-one plugin for oVirt Engine's setup

%prep
%if %mead_build
%setup -q -T -b 0 -n rhsc
%else
%setup -c -q
%endif

%build

%install
rm -rf %{buildroot}/*
%if %mead_build
make PREFIX=%{buildroot}/ SOURCE_DIR=%_sourcedir RELEASE_VERSION=%{release} install_without_maven
%else
make PREFIX=%{buildroot}/ SOURCE_DIR=%_sourcedir install
%endif

# /usr/share/ovirt-engine/engine.ear/META-INF/maven and subdirs 
# end up go+rwx otherwise
find %{buildroot}/%{_engineeardir}/META-INF -type d -exec chmod go-w {} \;

%preun
if [ "$1" -eq 0 ]
then
    curdate=`date +"%Y_%m_%d_%H_%M_%%S"`
    if [[ -d %{_sysconfdir}/pki/%{upname} ]]; then
        mkdir -p %{_sysconfdir}/pki/%{upname}-backups/%{upname}-${curdate}
        #backup whole 'rhsc' dir into the backup dir with current date
        cp -pR %{_sysconfdir}/pki/%{upname}/ %{_sysconfdir}/pki/%{upname}-backups/%{upname}-${curdate}/
    fi
fi

%postun
if [ "$1" -eq 0 ]
then
    if [[ -d %{_sysconfdir}/pki/%{upname} ]]; then
	    rm -rf %{_sysconfdir}/pki/%{upname}
	fi

    if [[ -f %{_sysconfdir}/yum/pluginconf.d/versionlock.list ]]
    then
        sed -i '/rhsc/d' %{_sysconfdir}/yum/pluginconf.d/versionlock.list
    fi
fi

%post
#ln -s %{_datadir}/vdsm-bootstrap %{_engineeardir}/components.war/vds &> /dev/null || /bin/true
# TODO: remove copy of vds dir after Jboss7.x will support symbolic links
if [[ -L %{_engineeardir}/components.war/vds ]]; then
    unlink %{_engineeardir}/components.war/vds &> /dev/null || /bin/true
fi

mkdir -p %{_engineeardir}/components.war/vds &> /dev/null || /bin/true
cp -rpf %{_datadir}/vdsm-bootstrap/* %{_engineeardir}/components.war/vds/ &> /dev/null || /bin/true

%pre
%{__getent} group kvm > /dev/null || %{__groupadd} -g 36 -r kvm
%{__getent} passwd vdsm > /dev/null || %{__useradd} -u 36 -g kvm -o -r vdsm -c "Ovirt node manager" -d / -s /sbin/nologin

%{__getent} group ovirt > /dev/null || %{__groupadd} -g 108 ovirt
%{__getent} passwd ovirt > /dev/null || %{__useradd} -u 108 -g ovirt -o -r ovirt -c "Ovirt Manager" -d /var/lib/ovirt -s /sbin/nologin
%{__getent} passwd %{_jbossuser} > /dev/null && %{__usermod} -a -G %{_jbossuser} ovirt > /dev/null

%pre notification-service
%{__getent} group ovirt > /dev/null || %{__groupadd} -g 108 ovirt
%{__getent} passwd ovirt > /dev/null || %{__useradd} -u 108 -g ovirt -o -r ovirt -c "Ovirt Manager" -d /var/lib/ovirt -s /sbin/nologin
%{__getent} passwd %{_jbossuser} > /dev/null && %{__usermod} -a -G %{_jbossuser} ovirt > /dev/null

%post notification-service
%{__chown} ovirt:ovirt /etc/ovirt-engine/notifier/notifier.conf > /dev/null || /bin/true

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%dir %{_datadir}/%{upname}
%doc %{_datadir}/%{upname}/LICENSE
%dir %{_datadir}/%{upname}/resources
%dir %{_datadir}/%{upname}/ovirt-isos
%dir %{_datadir}/%{upname}/db-backups
%dir %{_datadir}/%{upname}/scripts
%dir %{_localstatedir}/run/%{upname}
%dir %attr (755,%{_jbossuser},%{_jbossuser}) %{_var}/log/%{upname}
%dir %attr (755,%{_jbossuser},%{_jbossuser}) %{_var}/lock/%{upname}
%dir %{_sysconfdir}/%{upname}/sysprep
%attr (755,root,root) %{_datadir}/%{upname}/kerberos
%{_datadir}/%{upname}/conf
%attr (755,root,root) %{_datadir}/%{upname}/scripts/vds_installer.py*
%attr (755,root,root) %{_datadir}/%{upname}/scripts/ovirtlogrot.sh
%attr (755,root,root) %{_sysconfdir}/cron.daily/ovirt-cron
%attr (644,root,root) %{_sysconfdir}/tmpfiles.d/ovirt-engine.conf
%attr (755,%{_jbossuser},%{_jbossuser}) %{_datadir}/%{upname}/resources/jboss
%dir %{_sysconfdir}/%{upname}
%attr (755,%{_jbossuser},%{_jbossuser}) %{_sysconfdir}/pki/%{upname}
%attr (640,%{_jbossuser},%{_jbossuser}) %config(noreplace) %{_sysconfdir}/%{upname}/engine.conf

%config(noreplace) %{_sysconfdir}/pki/%{upname}/database.txt
%config(noreplace) %{_sysconfdir}/pki/%{upname}/serial.txt
%config(noreplace) %{_sysconfdir}/pki/%{upname}/cacert.template
%config(noreplace) %{_sysconfdir}/pki/%{upname}/cert.template
%config(noreplace) %{_sysconfdir}/%{upname}/web-conf.js
%config(noreplace) %{_sysconfdir}/%{upname}/sysprep/sysprep.2k3
%config(noreplace) %{_sysconfdir}/%{upname}/sysprep/sysprep.2k8
%config(noreplace) %{_sysconfdir}/%{upname}/sysprep/sysprep.2k8x86
%config(noreplace) %{_sysconfdir}/%{upname}/sysprep/sysprep.w7
%config(noreplace) %{_sysconfdir}/%{upname}/sysprep/sysprep.w7x64
%config(noreplace) %{_sysconfdir}/%{upname}/sysprep/sysprep.xp
%{_jbossdir}/modules/system/layers/base/org/postgresql

# RHSC Specific
%dir %{_sysconfdir}/%{name}

%files backend
%dir %{_engineeardir}
%{_engineeardir}/META-INF
%{_engineeardir}/lib
%{_engineeardir}/engine-bll.jar
%{_engineeardir}/engine-scheduler.jar
%{_engineeardir}/root.war
%{_engineeardir}/ovirtengineweb.war
%{_engineeardir}/ovirtengine.war
%{_engineeardir}/components.war
%dir %{_engineeardir}/webadmin.war

%files setup
%attr (755,root,root) %{_datadir}/%{upname}/scripts/basedefs.py*
%attr (755,root,root) %{_datadir}/%{upname}/scripts/engine_validators.py*
%attr (755,root,root) %{_datadir}/%{upname}/scripts/setup_params.py*
%attr (755,root,root) %{_datadir}/%{upname}/scripts/setup_sequences.py*
%attr (755,root,root) %{_datadir}/%{upname}/scripts/setup_controller.py*
%attr (755,root,root) %{_datadir}/%{upname}/scripts/common_utils.py*
%attr (755,root,root) %{_datadir}/%{upname}/scripts/output_messages.py*
%attr (755,root,root) %{_datadir}/%{upname}/scripts/nfsutils.py*
%attr (755,root,root) %{_datadir}/%{upname}/scripts/engine-setup.py*
%attr (755,root,root) %{_datadir}/%{upname}/scripts/engine-cleanup.py*
%attr (755,root,root) %{_datadir}/%{upname}/scripts/engine-upgrade.py*
%attr (755,root,root) %{_datadir}/%{upname}/scripts/post_upgrade.py*
%dir %attr (755,root,root) %{_datadir}/%{upname}/scripts/plugins
%attr (755,root,root) %{_datadir}/%{upname}/scripts/plugins/example_plugin_000.py
%attr (750,root,root) %{_bindir}/engine-setup
%attr (750,root,root) %{_bindir}/engine-upgrade
%attr (750,root,root) %{_bindir}/engine-check-update
%attr (750,root,root) %{_bindir}/engine-cleanup

# RHSC Specific
%attr (750,root,root) %{_bindir}/%{name}-setup
%attr (750,root,root) %{_bindir}/%{name}-upgrade
%attr (750,root,root) %{_bindir}/%{name}-check-update
%attr (750,root,root) %{_bindir}/%{name}-cleanup

#%files setup-plugin-allinone
#%attr(755,root,root) %{_datadir}/%{upname}/scripts/plugins/all_in_one_100.py

%files dbscripts
%attr (755,root,root) %{_datadir}/%{upname}/dbscripts

%files jboss-deps
%defattr(-,root,root,-)

%files restapi
%dir %{_engineeardir}
%{_engineeardir}/restapi.war

%files genericapi
%dir %{_engineeardir}
%{_engineeardir}/engine-genericapi.jar

%files userportal
%dir %{_engineeardir}
%config(noreplace) %{_engineeardir}/userportal.war/org.ovirt.engine.ui.userportal.UserPortal/consoles/spice/usbfilter.txt
%{_engineeardir}/userportal.war

%files webadmin-portal
%dir %{_engineeardir}
%{_engineeardir}/webadmin.war

%files tools-common
%{_datadir}/java/engine-tools-common-2.0.techpreview1.jar
%{_datadir}/java/engine-tools-common.jar

%files config
%{_datadir}/%{upname}/engine-config
%{_sysconfdir}/%{upname}/engine-config
%{_bindir}/engine-config
%{_datadir}/%{upname}/engine-manage-domains
%{_sysconfdir}/%{upname}/engine-manage-domains
%{_bindir}/engine-manage-domains


#RHSC Specific
%{_bindir}/%{name}-manage-domains
%{_bindir}/%{name}-config

%files notification-service
%defattr(-,ovirt,ovirt,-)
%dir %attr (755,ovirt,ovirt) %{_var}/log/%{upname}/notifier
%dir %attr (755,ovirt,ovirt) %{_localstatedir}/run/%{upname}/notifier
%{_datadir}/%{upname}/notifier
%{_sysconfdir}/%{upname}/notifier
%attr (755,root,root) %{_sysconfdir}/init.d/engine-notifierd
%config(noreplace) %{_sysconfdir}/%{upname}/notifier/notifier.conf

%changelog
* Wed May 27 2013 Kanagaraj M <kmayilsa@redhat.com> - 2.0.techpreview1-5
- packaging: Update to EAP 6.1 (BZ966864)
* Wed Mar 20 2013 Aravinda VK <avishwan@redhat.com> - 2.0.techpreview1-4
- packaging: Remove redundant DB user name (BZ922572)
- packaging: engine-setup - Use semange instead of setsebool(BZ923674)
* Mon May 07 2012 Keith Robertson <kroberts@redhat.com> - 3.1.0-3
- Removed image uploader, iso uploader, and log collector from this
  git repo.  The are now in their own respective ovirt.org git
  repos. BZ#803240.
* Wed Apr 04 2012 Stephen Gordon <sgordon@redhat.com> - 3.1.0-2
- The ovirt-engine spec file did not previously contain a BuildRequires
  statement for the maven package. As a result in mock environments the
  build failed with an error when attempting to call the 'mvn' binary -
  BZ#807761.
* Wed Jan 04 2012 Ronen Angluste <ranglust@redhat.com> - 3.1.0-1
- Adjust code for Jboss AS 7.1
* Sun Dec 11 2011 Ronen Angluster <ranglust@redhat.com> - 3.1.0-1
- Moved all hard coded paths to macros
* Wed Oct 26 2011 Ronen Angluster <ranglust@redhat.com> - 3.1.0-1
- Initial build
- Cloned from RHEVM spec file
